package com.huifu.adapay.core.util;


import com.huifu.adapay.core.AdapayCore;

import java.util.Iterator;
import java.util.Map;
import java.util.Set;

/**
 *
 */
public class WebUtils {

    public static String buildForm(String baseUrl, Map<String, Object> parameters, String charset) {
        StringBuffer sb = new StringBuffer();
        sb.append("<html>\n");
        sb.append("<head>\n");
        sb.append("<meta charset=\"").append(charset).append("\" > \n");
        sb.append("</head>\n");
        sb.append("<form name=\"form\" method=\"post\" action=\"").append(baseUrl).append("\">\n");
        sb.append(buildHiddenFields(parameters, charset));
        sb.append("</form>\n");
        sb.append("<script>document.form.submit();</script>\n");
        sb.append("</html>");
        String form = sb.toString();
        if (AdapayCore.debug) {
            System.out.println("生成的form内容：");
            System.out.println(form);
        }
        return form;
    }

    /**
     * 生成隐藏域
     *
     * @param parameters
     * @return
     */
    private static String buildHiddenFields(Map<String, Object> parameters, String charset) {
        if (parameters != null && !parameters.isEmpty()) {
            StringBuffer sb = new StringBuffer();
            Set<String> keys = parameters.keySet();
            Iterator var3 = keys.iterator();
            while (var3.hasNext()) {
                String key = (String) var3.next();
                String value = parameters.get(key).toString();
                if (key != null && value != null) {
                    sb.append(buildHiddenField(key, value, charset));
                }
            }
            String result = sb.toString();
            return result;
        } else {
            return "";
        }
    }

    private static String buildHiddenField(String key, String value, String charset) {
        StringBuffer sb = new StringBuffer();
        sb.append("<input type=\"hidden\" name=\"");
        sb.append(key);
        sb.append("\" value=\"");
        String a = value.replace("\"", "&quot;");
        sb.append(a).append("\">\n");
        return sb.toString();
    }


}

